(***********************************************************************)
(*                                                                     *)
(*                       Ambients in JoCaml                            *)
(*                                                                     *)
(*               Alan Schmitt, projet Para, INRIA Rocquencourt         *)
(*                                                                     *)
(*  Copyright 1999 Institut National de Recherche en Informatique et   *)
(*  Automatique.  Distributed only by permission.                      *)
(*                                                                     *)
(***********************************************************************)

open Trad
open Syntax
  
let main () =
  print_string "starting server\n";
  flush stdout;
  
  let def sub! (a, s, foo) = { 
   while Thread.delay 1.0; true do print_string ("state: "^s.to_string ()^"\n"); flush stdout; done; }
  and sub_in! (a, b, c, d) = {}
  and sub_out! (a, b, c, d) = {}
  and test_bang! () = {}
  and to_print! (c) = c ("")
  and get_id () | state! (n) = reply n | state (n+1)
  in
  let top_loc_e = {there = top_location; sub = sub; sub_in = sub_in; sub_out =sub_out} in
  print_string "registering get_id\n";
  Ns.register "get_id" get_id vartype;
  spawn {state (1)};
  print_string "starting translation of *toploc\n";
  ambient "*toploc" top_loc_e [] Zero true None 0
;;
      
Printexc.catch main ();
Join.server ();;
      
